<?php

$microseconds = round(microtime(true) * 1000);
$apisecret = $_POST['apisecret'];
$payfieldsapikey = $_POST['payfieldsapikey'];
$transactionsapikey = $_POST['transactionsapikey'];
$accountcredential = $_POST['accountcredential'];


#create account credental
$v2token = generateAuthTokenV2($apisecret, $accountcredential); // call the function with required inputs to generate AuthToken
echo $v2token;

# generate v2 authtoken

function generateAuthTokenV2($apisecret, $accountcredential) {
  $headerObj = new stdClass();
  $headerObj->alg = "HS256";
  $headerObj->typ = "JWT";
  $headerJSON = base64url_encode(json_encode($headerObj));

  $jwtPayloadObj = new stdClass();
  $jwtPayloadObj->account_credential = $accountcredential;
  $jwtPayloadObj->region = "US";
  $jwtPayloadObj->type = "AuthTokenV2";
  $jwtPayloadObj->ts = $GLOBALS['microseconds'];
  $payloadJSON = base64url_encode(json_encode($jwtPayloadObj));

  $signature = base64url_encode(hash_hmac('sha256', "{$headerJSON}.{$payloadJSON}", $apisecret, true));
  $authToken = "{$headerJSON}.{$payloadJSON}.{$signature}";
  return $authToken;
}

function base64url_encode($data) {
  return strtr(base64_encode($data), '+/', '-_');
}

#generate GUID for request id

function GUID() {
  if (function_exists('com_create_guid') == true) {
    return trim(com_create_guid(), '{}');
  }

  return sprintf('%04X%04X-%04X-%04X-%04X-%04X%04X%04X', mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(16384, 20479), mt_rand(32768, 49151), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535));
}

$requestId = "MER-" . GUID();

?>

